package org.cagrid.mms.common;

import java.rmi.RemoteException;

/**
 * The Metadata Model Service (MMS) provides operations for generating and semantically annotating standard caGrid metadata instances using information extracted from external metadata repositories.
 *
 * This class is autogenerated, DO NOT EDIT.
 * 
 * This interface represents the API which is accessable on the grid service from the client. 
 * 
 * @created by Introduce Toolkit version 1.3
 * 
 */
public interface MetadataModelServiceI {

  public org.oasis.wsrf.properties.GetMultipleResourcePropertiesResponse getMultipleResourceProperties(org.oasis.wsrf.properties.GetMultipleResourceProperties_Element params) throws RemoteException ;

  public org.oasis.wsrf.properties.GetResourcePropertyResponse getResourceProperty(javax.xml.namespace.QName params) throws RemoteException ;

  public org.oasis.wsrf.properties.QueryResourcePropertiesResponse queryResourceProperties(org.oasis.wsrf.properties.QueryResourceProperties_Element params) throws RemoteException ;

  /**
   * Generates a complete DomainModel for the specified Project
   *
   * @param umlProjectIdentifer
   *	The project to generate a DomainModel for.
   * @throws InvalidUMLProjectIndentifier
   *	
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForProject(org.cagrid.mms.domain.UMLProjectIdentifer umlProjectIdentifer) throws RemoteException, org.cagrid.mms.stubs.types.InvalidUMLProjectIndentifier ;

  /**
   * Generates a DomainModel for the specified Project, including only the specified packages
   *
   * @param umlProjectIdentifer
   *	The project to generate a DomainModel for
   * @param packageNames
   *	The package names to include
   * @throws InvalidUMLProjectIndentifier
   *	
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForPackages(org.cagrid.mms.domain.UMLProjectIdentifer umlProjectIdentifer,java.lang.String[] packageNames) throws RemoteException, org.cagrid.mms.stubs.types.InvalidUMLProjectIndentifier ;

  /**
   * Generates a complete DomainModel for the specified Project, including only the identified Classes
   *
   * @param umlProjectIdentifer
   *	The project to generate a DomainModel for
   * @param fullyQualifiedClassNames
   *	The fully qualified classnames to include in the model
   * @throws InvalidUMLProjectIndentifier
   *	
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForClasses(org.cagrid.mms.domain.UMLProjectIdentifer umlProjectIdentifer,java.lang.String[] fullyQualifiedClassNames) throws RemoteException, org.cagrid.mms.stubs.types.InvalidUMLProjectIndentifier ;

  /**
   * Generates a  DomainModel for the specified Project, including only the specified Classes, but excluding the specified Associations
   *
   * @param umlProjectIdentifer
   *	The project to generate a DomainModel for
   * @param fullyQualifiedClassNames
   *	The fully qualified Class names to include in the model
   * @param umlAssociationExclude
   *	A collection of UML Associations to exclude from the model
   * @throws InvalidUMLProjectIndentifier
   *	
   */
  public gov.nih.nci.cagrid.metadata.dataservice.DomainModel generateDomainModelForClassesWithExcludes(org.cagrid.mms.domain.UMLProjectIdentifer umlProjectIdentifer,java.lang.String[] fullyQualifiedClassNames,org.cagrid.mms.domain.UMLAssociationExclude[] umlAssociationExclude) throws RemoteException, org.cagrid.mms.stubs.types.InvalidUMLProjectIndentifier ;

  /**
   * Annotates the specified ServiceMetadata model with semantic information from the specified model, by mapping QNames to UMLClasses
   *
   * @param serviceMetadata
   *	The unannotated ServiceMetadata model
   * @param namespaceToProjectMappings
   *	An optional collection of mappings from URI Namespace to UMLProjects
   * @throws InvalidUMLProjectIndentifier
   *	Thrown if the identifier is null or contains invalid properties.
   */
  public gov.nih.nci.cagrid.metadata.ServiceMetadata annotateServiceMetadata(gov.nih.nci.cagrid.metadata.ServiceMetadata serviceMetadata,org.cagrid.mms.domain.NamespaceToProjectMapping[] namespaceToProjectMappings) throws RemoteException, org.cagrid.mms.stubs.types.InvalidUMLProjectIndentifier ;

  /**
   * Returns the metadata detailing the supported Model sources and their characteristics
   *
   */
  public org.cagrid.mms.domain.ModelSourceMetadata getModelSourceMetadata() throws RemoteException ;

}

